/* bxbasm : Scanmisc.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012        */


/* ----- function prototypes ----- */
#include "prototyp.h"



void ScanParam()                  /* parse function paramaters */
{   char ch;
    int pi, len;


    pi = e_pos;
    len = strlen(p_string);

    while(pi < len)
    {
        pi = get_alnum(pi, len);
        ch = p_string[pi];

        if(pi < len)
        {
            e_pos = pi;

            if((isdigit(ch)) || (ch == '.'))
            {
                GetNewTmp();      /* get new temp varname */
            }
            else if(isalpha(ch))  /* a variable name */
            {
                AddNewVar_A();
            }

            pi = e_pos;
            len = strlen(p_string);
        }
    }
}
/*---------- end ScanParam ----------*/



void ScanJump()                   /* parse numeric jump label */
{   char ch, newlabel[LLEN], label[LLEN];
    int pi, len;


    pi = e_pos;
    len = strlen(p_string);
    pi = get_alnum(pi, len);

    if(pi < len)
    {
        ch = p_string[pi];
        e_pos = pi;

        if(isdigit(ch))
        {
            strcpy(newlabel, "L");     /* correct numeric label */
            strcpy(label, get_varname());
            strcat(newlabel, label);
            StorNVar(newlabel);        /* save new label name */
        }
    }
}
/*---------- end ScanJump ----------*/



void ScanIf()
{   char ch, varname[VAR_NAME];
    int pi, len, type;

/* printf("ScanIf::%s", p_string); /**/

    pi = 0;
    ch = p_string[pi];
    len = strlen(p_string);

    while((ch != '\n') && (pi < len))
    {
        pi = iswhite(pi);
        ch = p_string[pi];
        e_pos = pi;

        if(ch == '\"')                 /* found a quoted string */
        {
            GetNewVar();               /* get new varname */
        }
        else if(isalpha(ch))
        {
            strcpy(varname, get_varname());      /* get varname */
            pi = e_pos;
            type = get_vtype(pi);                /* get variable type */

            if(type == 0)
            {
                Fix_String_A(varname);
            }
            else
            {
                if(strcmp(varname, "EOF") != 0)  /* not an EOF(f) */
                {
                    len = strlen(varname);
                    s_pos = pi - len;
                    type = get_Nvtype(pi);
                    Sav_Destin_A(type, varname); /* save destination name */
                }
                else
                {
                    pi++;              /* it's an EOF(f) */
                    pi = get_paren(pi, len);
                    e_pos = pi;
                }
            }
        }
        else if(isdigit(ch))
        {
            GetNewTmp();               /* get new temp varname */
        }

        pi = e_pos;
        len = strlen(p_string);
        pi = get_rightExp(pi);
        ch = p_string[pi];
    }

/* printf("scanif::%s", p_string); */

}
/*---------- end ScanIf ----------*/



void ScanFInput()                 /* parse INPUT# statement */
{   char ch, NVar[12], varname[VAR_NAME];
    int pi, len, type, ii;
    unsigned size;


    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];

    while((pi < len) && (ch != '\n'))  /* process up to line terminator */
    {
        pi = get_alpha(pi, len);

        if(pi < len)
        {
            type = get_vtype(pi);

            if(type == 0)
            {
                e_pos = pi;
                strcpy(varname, get_varname());  /* get varname */
                Fix_String_A(varname);
            }
            else
            {
                e_pos = pi;                 /* output a value */
                AddNewVar_A();
            }

            pi = get_NextOp(pi);
        }

        ch = p_string[pi];
    }

 /* printf("p_string:%s", format); */

}
/*------- end ScanFInput ----------*/
























